var callBackPool = {
      callBacks: {},
      addCallBack: function (func, methodName) {
        var callBackID = methodName + Date.now();
        this.callBacks[callBackID] = func;
        return callBackID
      },
      removeCallBack: function (methodName) {
        if (typeof methodName === 'string') {
          var callBacks = this.callBacks;
          Object.keys(callBacks).forEach(function(key){
            if (key.indexOf(methodName) >= 0) {
              delete callBacks[key]
            }
          })
        }
      },
      removeAllCallBacks: function () {
        this.callBacks = {}
      },
      doCallBack: function (funcID, param) {
        var cbToCall = this.callBacks[funcID];
        cbToCall(param);
        if(funcID.indexOf('encrypt') >= 0){           callBackPool.removeCallBack(funcID);
         }      }
    };

    var cleanCallBack = function (funcID) {
      callBackPool.removeCallBack(funcID)
    };

    var getUnitedName = {
      ready: true,
      callAPI: function (methodName, param1, param2) {
        var object = {
          'method': methodName
        };

        var param1IsObj = typeof param1 === 'object';
        var param1IsFn = typeof param1 === 'function';
        var param2IsFn = typeof param2 === 'function';

    if(methodName !== 'encrypt'){        callBackPool.removeCallBack(methodName);
     }        if (!param1IsObj && !param1IsFn) {
          window.getBridgeName.callme(JSON.stringify(object));
          return
        };
        if (param1IsObj) {
          if (param1 !== null) {
            object['param'] = param1;
          }
          if (param2IsFn) {
            object['callBack'] = callBackPool.addCallBack(param2, methodName);
          }
          window.getBridgeName.callme(JSON.stringify(object));
          return
        }

        if (param1IsFn) {
          object['callBack'] = callBackPool.addCallBack(param1, methodName);
          window.getBridgeName.callme(JSON.stringify(object));
          return
        }
      }
    };

    window.callBackPool = callBackPool;
    window.getUnitedName = getUnitedName;
    window.cleanCallBack = cleanCallBack;

Process finished with exit code 0
