(function () {
    if (window.rcsdk) {
        console.log("rcsdk already exist!!!");
        return 110;
    }
    console.log("rcsdk init begin====");
    var win = window;
    var callbacks = {};
    var callbacksSticky = {};

    function closePage(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getAuthCode(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getAppInfo(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function isLogin(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function login(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getUA(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function showBackIcon(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function openBluetoothAdapter(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function closeBluetoothAdapter(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function onBluetoothAdapterStateChange(obj) {
        const callbackId = arguments.callee.name;
        invokeInner(callbackId, obj, true)
    }

    function offBluetoothAdapterStateChange(obj) {
        delete callbacksSticky['onBluetoothAdapterStateChange'];
        const callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getBluetoothAdapterState(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function startBluetoothDevicesDiscovery(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function onBluetoothDeviceFound(obj) {
        const callbackId = arguments.callee.name;
        invokeInner(callbackId, obj, true)
    }

    function offBluetoothDeviceFound(obj) {
        delete callbacksSticky['onBluetoothDeviceFound'];
        const callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function stopBluetoothDevicesDiscovery(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getBluetoothDevices(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function createBLEConnection(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function onBLEConnectionStateChange(obj) {
        const callbackId = arguments.callee.name;
        invokeInner(callbackId, obj, true)
    }

    function offBLEConnectionStateChange(obj) {
        delete callbacksSticky['onBLEConnectionStateChange'];
        const callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function closeBLEConnection(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getConnectedBluetoothDevices(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getBLEDeviceServices(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getBLEDeviceCharacteristics(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getBLEDeviceRSSI(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function notifyBLECharacteristicValueChange(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function onBLECharacteristicValueChange(obj) {
        const callbackId = arguments.callee.name;
        invokeInner(callbackId, obj, true)
    }

    function offBLECharacteristicValueChange(obj) {
        delete callbacksSticky['onBLECharacteristicValueChange'];
        const callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function readBLECharacteristicValue(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function writeBLECharacteristicValue(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function setBLEMTU(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getLocation(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function onLocationChange(obj) {
        const callbackId = arguments.callee.name;
        invokeInner(callbackId, obj, true)
    }

    function offLocationChange(obj) {
        delete callbacksSticky['onLocationChange'];
        const callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getStorage(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function getStorageSync(key) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        var params = {'key' : key};
        return NativeHandler.invoke(JSON.stringify(params), callbackId, '_rcsdk_callback_handler');
    }

    function setStorage(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function setStorageSync(key, value) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        var params = {'key' : key, 'value' : value};
        return NativeHandler.invoke(JSON.stringify(params), callbackId, '_rcsdk_callback_handler');
    }

    function removeStorage(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function removeStorageSync(key) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        var params = {'key' : key};
        return NativeHandler.invoke(JSON.stringify(params), callbackId, '_rcsdk_callback_handler');
    }

    function takePhoto(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function chooseImage(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function scan(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function pay(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function launchMiniProgram(obj) {
        var callbackId = arguments.callee.name + '_' + new Date().getTime();
        invokeInner(callbackId, obj);
    }

    function invokeInner(callbackId, obj, sticky = false) {
        console.log("invokeInner callbackId===" + callbackId + ", sticky=" + sticky);
        const { callback, ...params } = obj;
        if (typeof callback !== 'function') {
            console.error('callback param must be a function type!!!')
            return
        }

        const paramsStr = JSON.stringify(params);
        if (sticky) {
            callbacksSticky[callbackId] = callback
        } else {
            callbacks[callbackId] = callback;
        }
        NativeHandler.invoke(paramsStr, callbackId, '_rcsdk_callback_handler');
    }

    // ArrayBuffer转16进度字符串示例
    function _ab2hex_(buffer) {
      var hexArr = Array.prototype.map.call(
        new Uint8Array(buffer),
        function(bit) {
          return ('00' + bit.toString(16)).slice(-2)
        }
      )
      return hexArr.join('');
    }

    // 将16进制字符串转化为ArrayBuffer
    function _hex2ab_(hex) {
        return new Uint8Array(hex.match(/[\da-f]{2}/gi).map(function (h) {
          return parseInt(h, 16)
        })).buffer
    }

    function _notifyCallback(callbackId, jsonResp) {
        var json = JSON.parse(jsonResp);
        var callback = callbacksSticky[callbackId];
        var errCode = 0;
        if (callback) {
            errCode = 1;
            /*if (callbackId === 'onBluetoothDeviceFound' && json.code === 200 && json.data && json.data.devices) {
                var device = json.data.devices[0]
                if (device && device.advertisData) {
                    device.advertisData2 = _hex2ab_(device.advertisData)
                }
            }*/
            callback(json);
        } else {
            callback = callbacks[callbackId];
            if (callback) {
                callback(json);
                delete callbacks[callbackId];
            } else {
                errCode = -1;
            }
        }
        return errCode;
    }

    win._rcsdk_callback_handler = _notifyCallback;

    win.rcsdk = {
        closePage: closePage,
        getAuthCode: getAuthCode,
        getAppInfo: getAppInfo,
        isLogin: isLogin,
        login: login,
        getUA: getUA,
        showBackIcon: showBackIcon,
        openBluetoothAdapter: openBluetoothAdapter,
        closeBluetoothAdapter: closeBluetoothAdapter,
        onBluetoothAdapterStateChange: onBluetoothAdapterStateChange,
        offBluetoothAdapterStateChange: offBluetoothAdapterStateChange,
        getBluetoothAdapterState: getBluetoothAdapterState,
        startBluetoothDevicesDiscovery: startBluetoothDevicesDiscovery,
        onBluetoothDeviceFound: onBluetoothDeviceFound,
        offBluetoothDeviceFound: offBluetoothDeviceFound,
        stopBluetoothDevicesDiscovery: stopBluetoothDevicesDiscovery,
        getBluetoothDevices: getBluetoothDevices,
        createBLEConnection: createBLEConnection,
        onBLEConnectionStateChange: onBLEConnectionStateChange,
        offBLEConnectionStateChange: offBLEConnectionStateChange,
        closeBLEConnection: closeBLEConnection,
        getConnectedBluetoothDevices: getConnectedBluetoothDevices,
        getBLEDeviceServices: getBLEDeviceServices,
        getBLEDeviceCharacteristics: getBLEDeviceCharacteristics,
        getBLEDeviceRSSI: getBLEDeviceRSSI,
        notifyBLECharacteristicValueChange: notifyBLECharacteristicValueChange,
        onBLECharacteristicValueChange: onBLECharacteristicValueChange,
        offBLECharacteristicValueChange: offBLECharacteristicValueChange,
        readBLECharacteristicValue: readBLECharacteristicValue,
        writeBLECharacteristicValue: writeBLECharacteristicValue,
        setBLEMTU: setBLEMTU,
        getLocation: getLocation,
        onLocationChange: onLocationChange,
        offLocationChange: offLocationChange,
        getStorage: getStorage,
        getStorageSync: getStorageSync,
        setStorage: setStorage,
        setStorageSync: setStorageSync,
        removeStorage: removeStorage,
        removeStorageSync: removeStorageSync,
        takePhoto: takePhoto,
        chooseImage: chooseImage,
        scan: scan,
        pay: pay,
        launchMiniProgram: launchMiniProgram,
    };
    var ev = document.createEvent('HTMLEvents');
    ev.initEvent('RCSDKReady', false, false);
    document.dispatchEvent(ev);
    console.log("rcsdk init end====")
    return 111;
})();
